Package: COSNet
Type: Package
Title: Cost Sensitive Network for node label prediction on graphs with
        highly unbalanced labelings
Version: 1.47.0
Date: 2015-11-06
Author: Marco Frasca and Giorgio Valentini -- Universita' degli Studi
        di Milano
Maintainer: Marco Frasca<frasca@di.unimi.it>
Description: Package that implements the COSNet classification
        algorithm. The algorithm predicts node labels in partially
        labeled graphs where few positives are available for the class
        being predicted.
License: GPL (>= 2)
URL: https://github.com/m1frasca/COSNet_GitHub
LazyLoad: yes
Suggests: bionetdata, PerfMeas, RUnit, BiocGenerics
biocViews: GraphAndNetwork, Classification,Network, NeuralNetwork
Repository: https://bioc.r-universe.dev
Date/Publication: 2026-04-28 12:40:11 UTC
RemoteUrl: https://github.com/bioc/COSNet
RemoteRef: HEAD
RemoteSha: 88518b6b6f351d2ee367cb83e97f2afde4fcb752
NeedsCompilation: yes
Packaged: 2026-05-30 08:44:25 UTC; root
Built: R 4.6.0; x86_64-apple-darwin20; 2026-05-30 08:47:56 UTC; unix

library(COSNet)
test_optimizep <- function() {
    nitems <- 1000;
    neg_vect <- runif(nitems);
    pos_vect <- runif(nitems);
    labels <- sample(c(1,-1), nitems, replace=TRUE);
    res <- optimizep(pos_vect, neg_vect, labels)
    checkTrue(res$alpha >= 0 && res$alpha < pi/2)
    checkTrue(is.numeric(res$c))
    checkTrue(res$Fscore >= 0 && res$Fscore <= 1)
    checkTrue(is.numeric(res$pos_half))
}

find.division.not.strat <-
function(vett, n_fold)
{	
	n <- length(vett);
	if(n > n_fold){
		# get the actual seconds to set seed
		set.seed(as.integer(substring(Sys.time(), 18 ,19)));	
		# makes a permutation a random permutations of indexes before dividing its in various folds	
		d <- sample(vett, n);
		k <- floor(n/n_fold);	
		fold_list <- lapply(1:n_fold, function(x, d, k)
		              {return(d[(k*(x-1)+1):(k*x)])}, d=d, k=k);
		fold_list[[n_fold]] <- d[(k*(n_fold-1)+1):n];	
		return(fold_list);
	}
	else
		stop(paste(sep="", "The number of folds must be less or equal to the ",
		                     "length of the vector to be partitioned"));
}

library(COSNet)
test_find.division.not.strat <- function() {
    nitems <- 1000
    vect <- runif(nitems);    
    nfolds <- 10;    
    folds <- find.division.not.strat(vect, nfolds);    
    checkEquals(length(folds), nfolds)     
    checkEquals(sum(unlist(lapply(folds, length))), nitems)         
}

### R code from vignette source 'COSNet_v.Rnw'

###################################################
### code chunk number 1: a1
###################################################
library(COSNet);
library(bionetdata)
data(Yeast.STRING.data)
dim(Yeast.STRING.data)
rownames(Yeast.STRING.data)[1:10]


###################################################
### code chunk number 2: a2
###################################################
data(Yeast.STRING.FunCat)
dim(Yeast.STRING.FunCat)
rownames(Yeast.STRING.FunCat)[1:10]
colnames(Yeast.STRING.FunCat)[1:10]


###################################################
### code chunk number 3: a3
###################################################
## excluding the dummy "00" root
to.be.excl <- which(colnames(Yeast.STRING.FunCat) == "00")
Yeast.STRING.FunCat <- Yeast.STRING.FunCat[, -to.be.excl]
## choosing the first 35 classes
labeling <- Yeast.STRING.FunCat[, 1:35] 
## number of positive labels
colSums(labeling)       
Yeast.STRING.FunCat[Yeast.STRING.FunCat == 0] <- -1


###################################################
### code chunk number 4: a4
###################################################
out <- cosnet.cross.validation(labeling, Yeast.STRING.data, 5, cost=0)


###################################################
### code chunk number 5: a5
###################################################
out.r <- cosnet.cross.validation(labeling, Yeast.STRING.data, 5, cost=0.0001)


###################################################
### code chunk number 6: a6
###################################################
predictions <- out$predictions
scores <- out$scores;
labels <- out$labels;
predictions.r <- out.r$predictions
scores.r <- out.r$scores;
labels.r <- out.r$labels;


###################################################
### code chunk number 7: a7
###################################################
library(PerfMeas);
## computing F-score 
Fs <- F.measure.single.over.classes(labels, predictions);
## Average F-score 
Fs$average[4]
Fs.r <- F.measure.single.over.classes(labels.r, predictions.r);
# Average F-score for the regularized version of COSNet
Fs.r$average[4]
## Computing AUC
labels[labels <= 0] <- 0;
labels.r[labels.r <= 0] <- 0;
auc <- AUC.single.over.classes(labels, scores);
## AUC averaged across classes
auc$average
auc.r <- AUC.single.over.classes(labels.r, scores.r);
## AUC averaged across classes for the regularized version of COSNet
auc.r$average
## Computing precision at different recall levels
PXR <- precision.at.multiple.recall.level.over.classes(labels, 
scores, seq(from=0.1, to=1, by=0.1));
## average PxR
PXR$avgPXR
PXR.r <- precision.at.multiple.recall.level.over.classes(labels.r, 
        scores.r, seq(from=0.1, to=1, by=0.1));
## average PxR for the regularized version of COSNet
PXR.r$avgPXR


###################################################
### code chunk number 8: a8
###################################################
## reading similarity network W
W <- 
as.matrix(read.table(file=paste(sep="", "http://frasca.di.unimi.it/",
 "cosnetdata/u.sum.fly.txt"), sep=" "))
## reading GO annotations
GO.ann.sel <- 
as.matrix(read.table(file=paste(sep="", "http://frasca.di.unimi.it/",
"cosnetdata/GO.ann.fly.15.5.13.3_300.txt"), sep = " ",))
GO.classes <- colnames(GO.ann.sel)
## changing "." to ":"
GO.classes <- unlist(lapply(GO.classes, function(x){
                substr(x, 3, 3) <- ":"; return(x)}))
colnames(GO.ann.sel) <- GO.classes;      


###################################################
### code chunk number 9: a9
###################################################
n<-nrow(W);
## selecting some classes to be predicted
classes <- c("GO:0009605", "GO:0022414", "GO:0032504",
            "GO:0002376", "GO:0009888", "GO:0065003");
labels <- GO.ann.sel[, classes]
## for COSNet negative labels must be -1
labels[labels <= 0] <- -1;
## Determining a random partition for the class GO:0009605 in 3 folds
##    ensuring that each fold has a similar proportion of positives 
folds <- find.division.strat(labels[, 1], 1:n, 3)
## hiding the labels of the test set (the fold of index 1)
labels[folds[[1]], ] <- 0;
## predicting the hidden labels for each class with COSNet
res <- apply(labels, 2, function(x, W, cost){
        return(COSNet(W, x, cost))},
        W = W, cost = 0.0001);


###################################################
### code chunk number 10: a10
###################################################
library(PerfMeas);
## last predicted term
term.ind <- 6;
scores <- res[[term.ind]]$scores;
test.genes <- names(scores);
test.labels <- as.vector(GO.ann.sel[test.genes, term.ind]);
pos.labels <- sum(test.labels > 0)
pos.labels
alpha <- res[[term.ind]]$alpha
gamma <- res[[term.ind]]$c
alpha
gamma
AUC <- AUC.single(scores, test.labels)
AUC
P10R <- precision.at.recall.level(scores, test.labels,
rec.level = 0.1)
P10R


###################################################
### code chunk number 11: a11
###################################################
library(bionetdata);
## similarity matrix DD.chem.data
data(DD.chem.data); 
## label matrix DrugBank.Cat
data(DrugBank.Cat); 


###################################################
### code chunk number 12: a12
###################################################
n <- nrow(DD.chem.data);
drugs <- rownames(DD.chem.data);
drug.category <- c("Cephalosporins");
labels <- as.vector(DrugBank.Cat[, drug.category]);
names(labels) <- rownames(DrugBank.Cat);
## Determining a random partition in 5 folds ensuring that each 
##    fold has a similar proportion of positives
folds <- find.division.strat(labels, 1:n, 5)
labels[labels <= 0] <- -1;
## hiding the test labels (the fold of index 1)
test.drugs <- folds[[1]];
training.drugs <- setdiff(1:n, test.drugs);
labels[test.drugs] <- 0;


###################################################
### code chunk number 13: a13
###################################################
points <- generate_points(DD.chem.data, test.drugs, labels);
str(points)
opt_parameters <- optimizep(points$pos_vect[training.drugs],
                points$neg_vect[training.drugs], labels[training.drugs]);


###################################################
### code chunk number 14: a14
###################################################
## alpha parameter
alpha <- opt_parameters$alpha;
## gamma parameter
gamma <- opt_parameters$c;
## optimal F-score achieved during learning phase 
    ## procedure (see Frasca et al. 2013)
Fscore <- opt_parameters$Fscore;
res <- runSubnet(DD.chem.data, labels, alpha, gamma, cost=0.035);


###################################################
### code chunk number 15: a15
###################################################
library(PerfMeas)
str(res)
res$iter
labels <- as.vector(DrugBank.Cat[, drug.category]);
names(labels) <- rownames(DrugBank.Cat);
test.names <- names(res$scores);
AUC <- AUC.single(res$scores, labels[test.names]);
AUC;
P10R <- precision.at.recall.level(res$scores, 
        labels[test.names], rec.level=0.1);
P10R;
Fs <- F.measure.single(res$state, labels[test.names]);
Fs


###################################################
### code chunk number 16: a16
###################################################
library(bionetdata);
data(DD.chem.data); 
data(DrugBank.Cat); 
labels <- DrugBank.Cat;
labels[labels <= 0] <- -1;
out <- cosnet.cross.validation(labels, DD.chem.data,
        5, cost=0.035);
Fs <- F.measure.single.over.classes(labels, out$predictions);
Fs$average[4];
labels[labels <= 0] <- 0;
auc <- AUC.single.over.classes(labels, out$scores);
auc$average
PXR <- precision.at.multiple.recall.level.over.classes(labels,
        out$scores, seq(from=0.1, to=1, by=0.1));
PXR$avgPXR

runSubnet <-
function(W, labeling, alpha_value, c_value, cost) { 
	unlabeled <- which(labeling == 0);			
	p <- length(unlabeled);
	n <- length(labeling);
	# number of positives in training
	N_pos <- length(which(labeling[-unlabeled] == 1));	
	# defining neuron values by considering the angle "alpha_value"	
	pos_state <- sin(alpha_value);
	neg_state <- -cos(alpha_value);					
	labeling[labeling == 1] <- pos_state;
	labeling[labeling == -1] <- neg_state;
	# thresholds for unlabeled nodes deriving from optimization phase
	thresholds <- rep(c_value, p);	
	# computing the contribution for unlabeled nodes from those labeled 
	thresholds.top <- W[unlabeled, ] %*% labeling;
	w_u <- W[unlabeled, unlabeled];				
	# setting final thresholds for unlabeled nodes			
	theta <- unlist(thresholds.top);		        	
	theta <- thresholds - theta;	
	diag(w_u) <- 0;
	# computing data due to regularization only when cost > 0. The regularization changes according to the position of the positive half-plane
	if( (cost > 0) && (alpha_value > pi/4)) {  
		eta <- (cost) * abs(tan( (alpha_value - pi/4)*2 ));
		data <- reg_data(w_u, theta, eta, pos_state, neg_state,
		       ceiling((N_pos/(n-p))*p))
		w_u <- data$W; 
	    theta <- data$theta;
		rm(data);	
    }	
	state <- vector("numeric", length = p);	
	genes <- rownames(W);
	scores <- vector("numeric", length = p);	
	# network dynamics		
	iter=0;	
	repeat
	{					
		iter <- iter + 1;
		out1 <- .C("global_update_under", as.double(w_u), as.double(theta),
		        as.double(pos_state), as.double(neg_state), as.double(state), 
		         as.double(scores), as.integer(p), PACKAGE="COSNet")
		new_state <- out1[[5]];		
		n_changes <- sum(new_state != state);
		if(n_changes == 0){
			scores <- out1[[6]]				
			break
		}	
		else		
			state <- new_state							
	}
	names(state) <- genes[unlabeled];
	names(scores) <- genes[unlabeled];	
	th.res <- (pos_state + neg_state)/2
	state[which(state > th.res)] <- 1
	state[which(state <= th.res)] <- -1
	res <- list(state = state, scores = scores, iter=iter);	
	return (res); 
}

library(COSNet)
test_runSubnet <- function() {
    nrow <- 500;
    ncol <- 500;
    ntest <- 50;
    cost <- 0.0001;
    alpha_value <- 1;
    c_value <- 0;
    W <- matrix(runif(nrow*ncol), nrow=nrow);
    rownames(W) <- colnames(W) <- 1:nrow;
    labels <- sample(c(1,-1), nrow, replace = TRUE);
    names(labels) <- 1:nrow
    test <- sample(1:nrow, ntest);
    labels[test] <- 0;
    res <- runSubnet(W, labels, alpha_value, c_value, cost)
    checkTrue(checkEquals(min(res$state), 1) || checkEquals(min(res$state), -1))
    checkTrue(checkEquals(max(res$state), 1) || checkEquals(max(res$state), -1))
    checkEquals(sign(res$state), sign(res$scores))     
    checkTrue(is.numeric(res$iter))     
}

generate_labels <-
function(n, pos_rate)
{
	set.seed(as.integer(substring(Sys.time(), 15 ,16)));
	# generates n random number between 0 and 1				
	y_rand <- runif(n, 0, 1)
	y_rand_tmp <- y_rand;
	y_rand[y_rand_tmp <= pos_rate] <- 1;
	y_rand[y_rand_tmp > pos_rate] <- -1;	
	return(y_rand);					
}

library(COSNet)
test_generate_labels <- function() {
    nitems <- 1000       
    pos.rate <- 0.2;
    labels <- generate_labels(nitems, pos.rate);       
    checkEquals(length(labels), nitems)     
    checkTrue(min(labels) == -1 || min(labels) == 1);
    checkTrue(max(labels) == -1 || max(labels) == 1);
}

reg_data <-
function(W, theta, eta, M, m, pos_num) {	
	N <- length(theta);
	a <- 1/(M - m);
	b <- -m/(M - m);
	W <- W - (2 * eta * (a^2));
	theta <- theta + eta*a*(2*b*(N - 1) - 2*pos_num + 1);	
	diag(W) <- 0;	
	res <- list(W = W, theta = theta);
	return (res);
}

library(COSNet)
test_reg_data <- function() {
    nrow <- 500;
    ncol <- 500;    
    eta <- 0.5
    alpha <- pi/4;
    M <- sin(alpha);
    m <- -cos(alpha);
    W <- matrix(runif(nrow*ncol), nrow=nrow);
    W <- (W + t(W))/2;
    pos_num <- round(0.3*nrow);
    theta <- runif(nrow, -1, 1);  
    data <- reg_data(W, theta, eta, M, m, pos_num);
    checkEquals(sum(diag(data$W)), 0);
    checkTrue(isSymmetric(data$W));    
}

optimizep <-
function(pos_vect, neg_vect, training_labels) {	
	alpha <- 0; c <- 0;
	Fscore <- -1.0; pos_halfplane <- 0;
	N <- length(training_labels);
	# function to optimize the model parameters										
	out2 <- .C("error_minimization",as.double(pos_vect),as.double(neg_vect),
	         as.integer(training_labels), as.integer(N), as.double(alpha), 
	          as.double(c), as.double(Fscore), as.integer(pos_halfplane), 
	           PACKAGE="COSNet");	
	res <- list(alpha = out2[[5]], c = out2[[6]], Fscore = out2[[7]], 
	       pos_half = out2[[8]]);
#	res[[1]] <- out2[[5]];	res[[2]] <- out2[[6]];
#	res[[3]] <- out2[[7]];	res[[4]] <- out2[[8]];
	if(res$pos_half < 0)
		return (res)
	else	
		out2 <- optimize_pos_above(pos_vect, neg_vect, training_labels, res)	
	return (out2);						
}

library(COSNet)
test_optimize_pos_above <- function() {
    nitems <- 1000;
    neg_vect <- runif(nitems);
    pos_vect <- runif(nitems);
    labels <- sample(c(1,-1), nitems, replace=TRUE);
    res <- list(alpha = pi/4, c = runif(1), Fscore = runif(1), pos_half = runif(1))
    optimize_pos_above(pos_vect, neg_vect, labels, res);    
    checkTrue(res$alpha >= 0 && res$alpha < pi/2)
    checkTrue(is.numeric(res$c))
    checkTrue(res$Fscore >= 0 && res$Fscore <= 1)   
}

optimize_pos_above <-
function(pos_vect, neg_vect, training_labels, res)
{		
    n <- length(pos_vect);
    zero.abscissa <- which(pos_vect == 0); # nodes with no positive neighbors
    n.point <- length(zero.abscissa)
		#*************************************************************************
		# Step 1******************************************************************
    ordinate.zero.abscissa <- neg_vect[zero.abscissa]; # ordinates of points with no positive neighbors
		# indices (in zero.ascissa) of positive nodes with no positive neighbors 
    positive.ordinate.zero.abscissa<-which(training_labels[zero.abscissa] > 0) 
		# permutation of "ordinate.zero.abscissa" corresponding to the increasing sorted sequance
    ordinate.zero.abscissa.order <- order(ordinate.zero.abscissa);	
		# sorted "ordinate.zero.abscissa"
    ordinate.zero.abscissa.sort <- sort(ordinate.zero.abscissa);	
    n.pos <- length(positive.ordinate.zero.abscissa);
    best.F <- 0; best.index <- 0; TP  <- FP <- 0; FN <- n.point;
		# selecting the indices of positive nodes with absissa 0 in the sorted vector of the corresponding ordinates. 
    ord.pos.ind <- sort(which(ordinate.zero.abscissa.order %in% 
                    positive.ordinate.zero.abscissa))	
      # if there is at least a positive node with ascissa 0
    if(n.pos > 0){
			# scans all the lines passing for a positive point and with negative slopes, and for each of it computes the corresponding F-score
			# by considering the positive half-plane below the line			
        for(i in 1:n.pos){
            act.pos <- ord.pos.ind[i] # position in the sorted oridinates vector
				# the ordinate of the actual point
            act.ord <- ordinate.zero.abscissa.sort[act.pos]
				# it means that the line with negative slope passing for this point classifies in wrong all the negatives under the 
				# line (the positive hal-plane is below the line). 
            TP <- i; FN <- n.pos - TP; FP <- act.pos - TP
            if((TP + FP)!=0 & TP + FN != 0)
                act.F <- (2*(TP/(TP + FP))*(TP/(TP + FN)))/(TP/(TP + FP) + 
                         TP/(TP + FN))
            else   act.F <- 0					
            if(act.F > best.F)	{
                best.F <- act.F;	best.index <- act.pos
            } 
		}			
			# *******************************************************************************************
			# Step 2*************************************************************************************
			# after found the positive point P (corresponding to best.index) with abscissa 0 corresponding to the best Fscore,
			# it computes the Fscore corresponding to the lines crossing P and all the ramaining points with ascissa > 0. 
        x_1 <- 0; y_1 <- ordinate.zero.abscissa.sort[best.index] 
        slopes <- vector();
			# number of points with abscissa > 0
        n.non.zero <- n - n.point
		# computing slopes of all the lines crossing P and all the ramaining points with ascissa > 0
        for (j in 1:n.non.zero){
            x_2 <- (pos_vect[-zero.abscissa])[j];
            y_2 <- (neg_vect[-zero.abscissa])[j]
            slopes[j] <- (y_2 - y_1)/((x_2 - x_1))
        }
        sub.labels <- training_labels[-zero.abscissa]
        slopes.order <- order(slopes);  slopes.sort <- sort(slopes)
			# positive points among those with abscissa > 0
        positive.up <- which(training_labels[-zero.abscissa] > 0)
        TP <- which(ord.pos.ind == best.index)
        FN <- n.pos - TP; FP <- best.index - TP;			
        best.F<-(2*(TP/(TP + FP))*(TP/(TP + FN)))/(TP/(TP + FP) + TP/(TP + FN));
        FN <- FN + length(positive.up)			
        best.slope <- tan(1.58) # almost vertical line as default
        number.slopes.filtered <- 0
        # computing the best Fscores among these lines scannig in an incresing order of slopes 
        for(j in 1:n.non.zero){
            if(slopes.sort[j] > -1) { # considers just the lines with slope in ]-Inf, -1]
                next # angle not acceptable
            }
            else	{
                number.slopes.filtered <- number.slopes.filtered + 1
                if(sub.labels[slopes.order[j]] > 0){
                    TP <- TP + 1;	FN <- FN - 1					
                }	
                else	FP <- FP + 1					
                if((TP + FP)!=0 & TP + FN != 0)
                    act.F <- (2*(TP/(TP + FP))*(TP/(TP + FN)))/(TP/(TP + FP)
                              + TP/(TP + FN))
                else act.F <- 0
                if(act.F > best.F) {
                    best.F <- act.F;	best.slope <- slopes.sort[j];
                }			
            }
        }
			# *******************************************************************************************
			# Step 3 *************************************************************************************
			#after found the optimal angle, computing intercept
        intercepts <- vector();
        for (j in 1:n){
            x_2 <- pos_vect[j]; y_2 <- neg_vect[j]
            intercepts[j] <- y_2 - best.slope*x_2
        }
        intercepts.order<-order(intercepts); intercepts.sort <- sort(intercepts)			
        FP <- 0; TP <- 0; FN <- sum(training_labels>0)						
        best.F <- 0; best.intercept <- 0;
        for(j in 1:n){				
            if(training_labels[intercepts.order[j]] > 0)	{				
                TP <- TP + 1; FN <- FN - 1					
            }	
            else	FP <- FP + 1							
            if(TP > 0)
                act.F <- (2*(TP/(TP + FP))*(TP/(TP + FN)))/(TP/(TP + FP) 
                          + TP/(TP + FN))
            else 	act.F <- 0
            if(act.F > best.F) {
                best.F <- act.F;	best.intercept <- intercepts.sort[j]
             }		
        }
        res$alpha <- atan(best.slope)+pi;
        res$c <- -best.intercept*cos(res$alpha);
        res$Fscore <- best.F
        return (res)
    }
    else	{
			# No positive points with abscissa = 0
        return (res)		
    }
		
}

generate_points <-
function(W, unlabeled, labeling) {
	n <- nrow(W);
	N <- length(labeling[-unlabeled]);
	N_pos <- length(which(labeling[-unlabeled] == 1));
	pos_rate <- N_pos/N;					
	p <- length(unlabeled);
	# generating random labels for unlabeled nodes according to the distribution B(p, N_pos/N) 			
	y_rand <- generate_labels(p, pos_rate);		
	labeling[unlabeled] <- y_rand;			
	labeling[labeling <=0] <- 0;
	pos_vect <- W %*% labeling;	
	neg_vect <- W %*% (1-labeling)
	res <- list(pos_vect = pos_vect, neg_vect = neg_vect);
	return (res);
}

COSNet <-
function(W, labeling, cost=0){	
	unlabeled <- which(labeling == 0);	
	pos.labels <- sum(labeling>0)
	### Step 1		            	
   #computes points for the separation phase   	
   points <- generate_points(W, unlabeled, labeling);
	### Step 2
	# compute optimal parameters	
	opt_parameters <- optimizep(points$pos_vect[-unlabeled], 
	                  points$neg_vect[-unlabeled], labeling[-unlabeled]);
	alpha <- opt_parameters$alpha;
	c <- opt_parameters$c;
	Fscore <- opt_parameters$Fscore;	
	rm(opt_parameters);	
	### Step 3
	#compute predictions and scores for unlabeled nodes
	res <- runSubnet(W, labeling, alpha, c,  cost);
	out <- list(alpha = alpha, c = c, Fscore = Fscore, pred = res$state, 
	            scores = res$scores, iter = res$iter);
	return(out);			
}

.onLoad <- function(libname=.libPaths(), pkgname="COSNet")
       library.dynam("COSNet", pkgname, libname);
	   
.onAttach <- function(libname=.libPaths(), pkgname="COSNet")
 cat("COSNet: Cost-Sensitive algorithm for binary classification in graphs.\n");

library(COSNet)
test_COSNet <- function() {
    nrow <- 500;
    ncol <- 500;
    ntest <- 50;
    W <- matrix(runif(nrow*ncol), nrow=nrow);
    rownames(W) <- colnames(W) <- 1:nrow;
    labels <- sample(c(1,-1), nrow, replace = TRUE);
     names(labels) <- 1:nrow
    test <- sample(1:nrow, ntest);
    labels[test] <- 0;
    res <- COSNet(W, labels);
    checkTrue(checkEquals(min(res$pred), 1) || checkEquals(min(res$pred), -1))
    checkTrue(checkEquals(max(res$pred), 1) || checkEquals(max(res$pred), -1))
    checkEquals(sign(res$pred), sign(res$scores))
    checkTrue(res$alpha >= 0 && res$alpha < pi/2)
    checkTrue(is.numeric(res$c))
    checkTrue(res$Fscore >= 0 && res$Fscore <= 1)
    checkTrue(is.numeric(res$iter))     
}

cosnet.cross.validation <-
function(labels, W, nfolds, cost=0.0001)
{		
	n <- nrow(labels);
	m <- ncol(labels);	
	genes <- rownames(W);
	predictions <- matrix(0, nrow = n, ncol = m);        
	scores <- matrix(0, nrow = n, ncol = m);        	
	rownames(scores) <- rownames(predictions) <- genes;
	labels[labels <= 0] <- -1;	
	tmp.sum <- apply(W, 1, sum);
	isolated <- which(tmp.sum == 0);	
	labels.noiso <- labels;
	if(length(isolated) > 0){
		W <- W[-isolated, -isolated]
		labels.noiso <- as.matrix(labels.noiso[-isolated, ])
    	n <- nrow(W)
    }
	for(i in 1:m){		
		labeling <- as.vector(labels.noiso[, i]);	
		fold_indexes <- find.division.strat(labeling, 1:n, nfolds);	
		nodes <- rownames(labels.noiso);
		for(j in 1:length(fold_indexes)){		
			test <- as.vector(fold_indexes[[j]]);				
			labelingTMP <- labeling;
			labelingTMP[test] <- 0;			
			out <- COSNet(W, labelingTMP, cost)	
			predictions[nodes[sort(test)], i] <- out$pred;
			scores[nodes[sort(test)], i] <- out$scores;		
		}
	}
	classes <- colnames(labels);
	if(length(classes) > 0)
		colnames(scores) <- colnames(predictions) <- classes	
	out <- list(labels = labels, predictions = predictions, scores = scores);
	return (out);
}

library(COSNet)
test_cosnet.cross.validation <- function() {
    nrow <- 500;
    ncol <- 500;
    nfolds <- 10;
    cost <- 0.0001
    W <- matrix(runif(nrow*ncol), nrow=nrow);
    rownames(W) <- colnames(W) <- 1:nrow;
    labels <- matrix(sample(c(1,-1), nrow, replace=TRUE), nrow=nrow, ncol = 1);    
    rownames(labels) <- 1:nrow
    colnames(labels) <- "c1"
    res <- cosnet.cross.validation(labels, W, nfolds, cost);    
    checkTrue(checkEquals(min(res$predictions), 1) || checkEquals(min(res$predictions), -1))
    checkTrue(checkEquals(max(res$predictions), 1) || checkEquals(max(res$predictions), -1))
    checkEquals(sign(res$predictions), sign(res$scores))     
}

find.division.strat <-
function(labels, vett, n_fold)
{
	n <- length(vett);
	if(n > n_fold){
		# get the actual seconds to set seed
		set.seed(as.integer(substring(Sys.time(), 18 ,19)));		
		pos = which(labels > 0);
		npos <- length(pos)	
		vett.pos <- vett[pos];
		if(npos >= n_fold){	#stratified partition			
			d <- vett[-pos];
			d <- sample(d, (n-npos));
			k <- round((n-npos)/n_fold);
			kp <- round((npos)/n_fold);	
			fold_indices <- lapply(1:n_fold, function(x, d, k, kp, vett.pos)
			                   { return(c(d[(k * (x - 1) + 1):(k * x)], 
			                            pos[(kp * (x - 1) + 1):(kp * x)])) }, 
			                  d = d, k = k, kp = kp, vett.pos = vett.pos);
			fold_indices[[n_fold]] <- c( d[(k*(n_fold-1)+1):(n-npos)], 
			                              vett.pos[(kp*(n_fold-1)+1):npos]);		
		}
		else # not stratified 
			fold_indices <- find.division.not.strat(1:n, n_fold)

		return (fold_indices);	
	}
	else
		stop(paste(sep="", "The number of folds must be less or equal to the ",
		                     "length of the vector to be partitioned"));	

}

library(COSNet)
test_find.division.strat <- function() {
    nitems <- 1000       
    nfolds <- 10;
    labels <- sample(c(1,-1), nitems, replace=TRUE);    
    npos <- sum(labels>0);        
    cat(npos/nitems, "\n");
    folds <- find.division.strat(labels, 1:nitems, nfolds);    
    checkEquals(length(folds), nfolds)     
    checkEquals(sum(unlist(lapply(folds, length))), nitems)
	checkEqualsNumeric(sum(unlist(lapply(folds, function(x){return(checkEqualsNumeric(sum(labels[x]>0)/length(x), npos/nitems, tolerance=1.0e-1))}))), 10);
}

\documentclass[a4paper,11pt]{article}


%\VignetteIndexEntry{An R Package for Predicting Binary Labels in Partially-Labeled Graphs}
%\VignetteDepends{COSNet}
%\VignetteDepends{bionetdata}


\usepackage{amsmath}
\usepackage[authoryear,round]{natbib}
\usepackage{hyperref}
\usepackage{amssymb}
\newcommand{\Rp}[1]{{\textit{#1}}}
\newcommand{\bW}{\boldsymbol{W}}
\newcommand{\bu}{\boldsymbol{u}}
%\newcommand{\bW}{\boldsymbol{W}}
\newcommand{\bx}{\boldsymbol{x}}
\begin{document}
\title{\Rp{COSNet}: An R Package for Predicting Binary Labels in Partially-Labeled Graphs}

\author{Marco Frasca and Giorgio Valentini}

\maketitle

\begin{center}
Dipartimento di Informatica\\
Universit\`a degli Studi di Milano\\
Via Comelico 39/41, 20135 Milano, Italy\\
{\tt frasca@di.unimi.it}
\end{center}

\section*{Scope and Purpose of this Document}
This document is a user manual for \Rp{COSNet}, the software implementing the model developed by Bertoni {\em et al.} (2011), Frasca {\em et al.} (2013). It provides an introduction into how to use COSNet. Not all features of the R package are
described in full detail. Such details can be obtained from the documentation enclosed in the R
package. 
\tableofcontents

\section{Introduction}
This package implements the algorithm \Rp{COSNet} (Bertoni \textit{et al. 2011}, Frasca \textit{et al. 2013}), which has been proposed for predicting node labels in partially labeled graphs, especially when labelings are highly unbalanced. In this context, nodes represent the instances of the problem, whose labels can be positive (+) or negative (-). Unbalanced labeling means that one class (usually the negative class) considerably outnumbers the other one. Many real world problems are characterized by few positives and much more negatives, such as the gene function prediction, where genes having the most specific biomolecular functions are very few (Ashburner \textit{et al. 2000}), or in medical diagnosys of  cancer, where patients having a certain cancer (positive class) are the large minority. The instances are only partially labeled, and the aim is to extend the labeling to all the instances. In this context, imbalance-unaware algorithms may suffer high decay in performance when classifying new instances (Ling and Sheng \textit{2007}). \textit{COSNet}  automaticly learns from the input data the model parameters able in dealing with the label imbalance, and efficiently infers binary labels for the unlabeled instances in the graph. 

Formally, the input of \textit{COSNet} is represented by a weighted graph $G=(V, \bW)$, where $V$ is the set of nodes and $\bW = (w_{ij}|_{i,j=1}^n)$ is the symmetric weight matrix with null diagonal: the weight $w_{ij}\in [0,1]$ denotes a similarity index of node $i$ with respect to node $j$. The labeling of $V$ in positive $V_+$ and negative $V_-$ nodes is known only for a subset $S\subset V$, while is unknown for $U=V\setminus S$. The aim is to extend the labeling to nodes in $U$, that is inferring a bipartition of $U$ in positive $U_+$ and negative $U_-$ instances. The labeling imbalance can be represented through a coefficient $\epsilon = |S_+|/|S_-|$, where $S_+$ and $S_-$ are the sets of positive and negative examples, respectively. The labeling is considered highly unbalanced when $\epsilon << 1$. 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section{COSNet}
 \textit{COSNet} is a binary classifier based on a parametric Hopfield network which embeds the partial labeling and node similarities $\bW$ and predict the binary labels for the unlabeled nodes through an asynchronous dynamics, which updates only the unlabeled neurons. In order to deal with label imbalance, the model introduces two parameters, $\alpha \in [0,\frac{\pi}{2}[$ and $\gamma \in \mathbb{R}$, determining respectively the neuron activation values ($\sin\alpha,\ -\cos\alpha$) and the neuron activation thresholds. The parameters are automatically learned by an efficient supervised procedure on the basis of the input data. The initial state for neuron $v \in V$ is set as follows:
\begin{displaymath}
x_v(0) = \left\{ \begin{array}{rl}
\sin\alpha \hspace{0.1cm}& \mbox{\hspace{0.1cm} if \ $v$ is positive labeled}\\
-\cos\alpha \hspace{0.1cm}& \mbox{\hspace{0.1cm} if \ $v$ is negative labeled}\\
0 \hspace{0.1cm}& \mbox{\hspace{0.1cm} if \ $v$ is unlabeled}\\
\end{array}
\right.
\label{eq:DHN_update}
\end{displaymath}
For each unlabeled node $i$, the initial state $x_i =0 $ is changed to $-\cos\alpha$ or to $\sin\alpha$ according to the following asynchronous dynamics:
\begin{displaymath}
\begin{small}
{\begin{scriptsize} x_i(t)= \end{scriptsize}} \left\{ \begin{array}{rl}
\sin\alpha &\mbox{if\ } \overset{i-1}{\underset{j=1}\sum} W_{ij}x_j(t) + \overset{n}{\underset{k=i+1}\sum} W_{ik}x_k(t-1) - \gamma > 0\\
-\cos\alpha &\mbox{if\ } \overset{i-1}{\underset{j=1}\sum} W_{ij}x_j(t) + \overset{n}{\underset{k=i+1}\sum} W_{ik}x_k(t-1) - \gamma \leq 0\\
\end{array}
\right.
\label{eq:HN_U_update}
\end{small}
\end{displaymath}
where $n = |V|$ and $t$ is the current time. 
At each time $t$, the state of the network is $\bx(t) = (x_1(t), x_2(t), \ldots, x_n(t))$, and a Lyapunov state function named \textit{energy function} is associated to the network:

\begin{displaymath}
E(\bx) = -\frac{1}{2} \sum_{\substack{i, j=1 \\ j \neq i}}^n{ W_{ij}x_i x_j } + \sum_{i = 1}^{n}{x_i \gamma}
\label{eq:energy}
\end{displaymath} 
The dynamics converges to an equilibrium state $\hat\bx$ corresponding to a minimum of $E$ (Frasca \textit{et.al 2013}), which is used to infer the bipartiton ($U_+, U_-$) of $U$: $U_+ = \{i \in U, \hat x_i = \sin\alpha\}$ and $U_- = \{i \in U, \hat x_i = -\cos\alpha\}$. 
Furthermore, \textit{COSNet} can been adopted as ranker by assigning to each neuron a score related to its internal energy at equilibrium. More precisely, the score assigned to neuron $i \in U$ is the following:
\begin{equation}
s(i) = \sum_{j \neq i} (W_{ij}\hat x_j - \gamma)
\label{eq:score} 
\end{equation}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section{An Example of the Usage of \Rp{COSNet} for the Functional Classification of Yeast Genes with the Functional Catalogue}
In this section we apply \Rp{COSNet} to predict the functions of yeast proteins. We adopt a binary protein-protein interactions data set of 2338 yeast proteins from the STRING data base (von Mering et al. 2002), contained in the R package \Rp{bionetdata}\footnote{The package can be downloaded at http://cran.r-project.org/web/packages/bionetdata/index.html.} and the corresponding Functional Catalogue (FunCat) annotations.
%representing interaction data from yeast two-hybrid assay, mass-spectrometry of purified complexes, correlated mRNA expression and genetic interactions. 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\subsection{Data Loading}
First, let us load the library and check the data: 
\begin{small}
<<a1>>=
library(COSNet);
library(bionetdata)
data(Yeast.STRING.data)
dim(Yeast.STRING.data)
rownames(Yeast.STRING.data)[1:10]
@
\end{small}
The named squared matrix \textit{Yeast.STRING.data} contains 1 in position ($i$, $j$) if the corresponding proteins interact, 0 otherwise. 
In the same package, in order to define the binary labels, we load the annotations of 176 FunCat classes for the proteins included in \textit{Yeast.STRING.data}. Annotations refer the funcat-2.1 scheme, and funcat-2.1 data 20070316 data, available from the MIPS web site\footnote{http://mips.gsf.de/projects/funcat}. 

<<a2>>=
data(Yeast.STRING.FunCat)
dim(Yeast.STRING.FunCat)
rownames(Yeast.STRING.FunCat)[1:10]
colnames(Yeast.STRING.FunCat)[1:10]
@

The number of columns is 177 because the authors added a dummy class "00". Even in this case, \textit{Yeast.STRING.FunCat} is a binary matrix whose $i,j-th$ component is 1 if protein $i$ is annotated with class $j$, 0 otherwise. Note that the row names of both \textit{Yeast.STRING.FunCat} and \textit{Yeast.STRING.data} are identical. We first exclude the dummy class, that is useful only when hierarchical computations are performed, and then we select some classes and, since \Rp{COSNet} needs $\{1, -1\}$-labels, we change each 0-component of \textit{Yeast.STRING.FunCat} to -1.

<<a3>>=
## excluding the dummy "00" root
to.be.excl <- which(colnames(Yeast.STRING.FunCat) == "00")
Yeast.STRING.FunCat <- Yeast.STRING.FunCat[, -to.be.excl]
## choosing the first 35 classes
labeling <- Yeast.STRING.FunCat[, 1:35] 
## number of positive labels
colSums(labeling)       
Yeast.STRING.FunCat[Yeast.STRING.FunCat == 0] <- -1
@
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\subsection{Predicting Labels for Unlabeled Nodes with \Rp{COSNet}}
Now we predict the node labels through a 5-fold cross validation procedure implemented by the function \texttt{cosnet.cross.validation} provided by the \texttt{COSNet} package. This procedure at each time hides the labels in a fold and predicts them with \Rp{COSNet}. 
<<a4>>=
out <- cosnet.cross.validation(labeling, Yeast.STRING.data, 5, cost=0)
@    
Note that the \texttt{cost} parameter of \Rp{COSNet} is set to 0: this means that the unregularized version is adopted. 
Now we test the regularized version of \Rp{COSNet} on the same data:

<<a5>>=     
out.r <- cosnet.cross.validation(labeling, Yeast.STRING.data, 5, cost=0.0001)
@
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\subsection{Processing the Results}
The output of the \texttt{cosnet.cross.validation} function is a list whose fields are: "labels", named matrix containing the input labels; "predictions", named matrix containing the binary predictions; "scores", named matrix containing the predicted scores according to Eq. (\ref{eq:score}).
<<a6>>=
predictions <- out$predictions
scores <- out$scores;
labels <- out$labels;
predictions.r <- out.r$predictions
scores.r <- out.r$scores;
labels.r <- out.r$labels;
@
\subsection{Assessing \Rp{COSNet} Performance}
We now evaluate the performance of \Rp{COSNet} in terms of F-score, Area under the ROC Curve (AUC) and in terms of Precision at $x$ Recall level (PxR). We use the R package \textit{PerfMeas}, which provides functions to compute the performance measures we need: 
<<a7>>=
library(PerfMeas);
## computing F-score 
Fs <- F.measure.single.over.classes(labels, predictions);
## Average F-score 
Fs$average[4]
Fs.r <- F.measure.single.over.classes(labels.r, predictions.r);
# Average F-score for the regularized version of COSNet
Fs.r$average[4]
## Computing AUC
labels[labels <= 0] <- 0;
labels.r[labels.r <= 0] <- 0;
auc <- AUC.single.over.classes(labels, scores);
## AUC averaged across classes
auc$average
auc.r <- AUC.single.over.classes(labels.r, scores.r);
## AUC averaged across classes for the regularized version of COSNet
auc.r$average
## Computing precision at different recall levels
PXR <- precision.at.multiple.recall.level.over.classes(labels, 
scores, seq(from=0.1, to=1, by=0.1));
## average PxR
PXR$avgPXR
PXR.r <- precision.at.multiple.recall.level.over.classes(labels.r, 
        scores.r, seq(from=0.1, to=1, by=0.1));
## average PxR for the regularized version of COSNet
PXR.r$avgPXR
@
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section{An Example of the Usage of \Rp{COSNet} for Inferring Gene Ontology Labels for Fly Genes}
In this section  we show an application of \Rp{COSNet} in predicting the Gene Ontology (GO)(Ashburner \textit{et al. 2000}) labels for $9361$ Drosophila melanogaster genes. The input similarity matrix is obtained by integrating several types of data, including co-expression, genetic interactions, protein ontologies and physical interactions. The Gene Ontology annotations (release 15-5-13) with $3$-$300$ annotated genes have been considered. Both data and annotations can be downloaded at \textit{http://frasca.di.unimi.it/cosnetdata/}.
\subsection{Data Loading}
<<a8>>=
## reading similarity network W
W <- 
as.matrix(read.table(file=paste(sep="", "http://frasca.di.unimi.it/",
 "cosnetdata/u.sum.fly.txt"), sep=" "))
## reading GO annotations
GO.ann.sel <- 
as.matrix(read.table(file=paste(sep="", "http://frasca.di.unimi.it/",
"cosnetdata/GO.ann.fly.15.5.13.3_300.txt"), sep = " ",))
GO.classes <- colnames(GO.ann.sel)
## changing "." to ":"
GO.classes <- unlist(lapply(GO.classes, function(x){
                substr(x, 3, 3) <- ":"; return(x)}))
colnames(GO.ann.sel) <- GO.classes;      
@
\subsection{Predicting GO Labels with \Rp{COSNet}}
Now we determine a random partition in 3 folds of the input data, hide the labels of the genes in one of these folds (test set), and use the labels in the other 2 folds as training set for \Rp{COSNet}.
<<a9>>=
n<-nrow(W);
## selecting some classes to be predicted
classes <- c("GO:0009605", "GO:0022414", "GO:0032504",
            "GO:0002376", "GO:0009888", "GO:0065003");
labels <- GO.ann.sel[, classes]
## for COSNet negative labels must be -1
labels[labels <= 0] <- -1;
## Determining a random partition for the class GO:0009605 in 3 folds
##    ensuring that each fold has a similar proportion of positives 
folds <- find.division.strat(labels[, 1], 1:n, 3)
## hiding the labels of the test set (the fold of index 1)
labels[folds[[1]], ] <- 0;
## predicting the hidden labels for each class with COSNet
res <- apply(labels, 2, function(x, W, cost){
        return(COSNet(W, x, cost))},
        W = W, cost = 0.0001);
@
\subsection{Result Evaluation}
The function \texttt{COSNet} returns a list with five members, including binary predictions, ranking scores, and learned parameters. We now show how to compute, for instance, the AUC and the P10R achieved for the first GO term. Moreover, we show the value learned for the model parameters.
<<a10>>=
library(PerfMeas);
## last predicted term
term.ind <- 6;
scores <- res[[term.ind]]$scores;
test.genes <- names(scores);
test.labels <- as.vector(GO.ann.sel[test.genes, term.ind]);
pos.labels <- sum(test.labels > 0)
pos.labels
alpha <- res[[term.ind]]$alpha
gamma <- res[[term.ind]]$c
alpha
gamma
AUC <- AUC.single(scores, test.labels)
AUC
P10R <- precision.at.recall.level(scores, test.labels,
rec.level = 0.1)
P10R
@
%As expected, the value of $\alpha$ is higher when the rate of positives decreases. Indeed, when $\alpha$ tends to $\pi/2$, the ratio $\frac{\sin\alpha}{\cos\alpha}$ gets larger, which means that it is more likely positive neurons propagate their labels during the network dynamics.
%The fields ``alpha" and ``c" allow to get the estimated values of the parameters $\alpha$, $\gamma$:
%<<a8>>=
%out$alpha
%out$c
%@  
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section{Usage of \Rp{COSNet} for Predicting Therapeutical Categories of Drugs}
This section shows an application of \Rp{COSNet} in predicting drugs categories from DrugBank for 1253 DrugBank
drugs. The drug similarity matrix and the corresponding labels are available in the R package \Rp{bionetdata}, and contain respectively the Tanimoto chemical structure similarity scores among the considered drugs and the 0/1 labels for 45 drug categories, where in postition $i,j$-th we have the value 1 whether the drug $i$ is associated with the drug category $j$, 0 otherwise.
\subsection{Loading the data}
<<a11>>=
library(bionetdata);
## similarity matrix DD.chem.data
data(DD.chem.data); 
## label matrix DrugBank.Cat
data(DrugBank.Cat); 
@
\subsection{Learning the Model Parameters}
We show now how to learn the \Rp{COSNet} parameters using the package function \texttt{optimizep}. Fixed one drug category, first of all, we determine a random stratified partition of the data using the function \texttt{find.division.strat} provided by the \Rp{COSNet} package, and then hide the labels of one fold and use the other folds as training set.
<<a12>>=
n <- nrow(DD.chem.data);
drugs <- rownames(DD.chem.data);
drug.category <- c("Cephalosporins");
labels <- as.vector(DrugBank.Cat[, drug.category]);
names(labels) <- rownames(DrugBank.Cat);
## Determining a random partition in 5 folds ensuring that each 
##    fold has a similar proportion of positives
folds <- find.division.strat(labels, 1:n, 5)
labels[labels <= 0] <- -1;
## hiding the test labels (the fold of index 1)
test.drugs <- folds[[1]];
training.drugs <- setdiff(1:n, test.drugs);
labels[test.drugs] <- 0;
@
Now we need to project the training nodes into a bidimensional space, step necessary for the learning procedure (Frasca \textit{et al. 2013}), and we can do it using the package function \texttt{generate$\_$points}, which returns a list with two fields: \textit{pos$\_$vect}, the named vector of abscissae of projected points and \textit{neg$\_$vect}, the named vector of ordinates of projected points. Then we can call the function \texttt{optimizep} to learn the parameters of the model. 
<<a13>>=
points <- generate_points(DD.chem.data, test.drugs, labels);
str(points)
opt_parameters <- optimizep(points$pos_vect[training.drugs],
                points$neg_vect[training.drugs], labels[training.drugs]);
@ 
\subsection{Running the Sub-network of Unlabeled Nodes to Infer Labels}
We now extend the learned parameters to the sub-network of unlabeled nodes and run it with the package function \texttt{runSubnet}.
<<a14>>=
## alpha parameter
alpha <- opt_parameters$alpha;
## gamma parameter
gamma <- opt_parameters$c;
## optimal F-score achieved during learning phase 
    ## procedure (see Frasca et al. 2013)
Fscore <- opt_parameters$Fscore;
res <- runSubnet(DD.chem.data, labels, alpha, gamma, cost=0.035);
@
\subsection{Extracting Predictions}
The output of the \texttt{runSubnet} function is a list with three fields: ``state" which is a named vector containing the binary predictions; ``scores", named vector containing the scores described in Eq. (\ref{eq:score}); ``iter", integer representing the network iterations needed to reach the fixed state. By means of this vectors, we can now compute the prediction performance.
<<a15>>=
library(PerfMeas)
str(res)
res$iter
labels <- as.vector(DrugBank.Cat[, drug.category]);
names(labels) <- rownames(DrugBank.Cat);
test.names <- names(res$scores);
AUC <- AUC.single(res$scores, labels[test.names]);
AUC;
P10R <- precision.at.recall.level(res$scores, 
        labels[test.names], rec.level=0.1);
P10R;
Fs <- F.measure.single(res$state, labels[test.names]);
Fs
@
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\subsection{Cross Validating \Rp{COSNet} in Predicting Drug Therapeutical Categories}
<<a16>>=
library(bionetdata);
data(DD.chem.data); 
data(DrugBank.Cat); 
labels <- DrugBank.Cat;
labels[labels <= 0] <- -1;
out <- cosnet.cross.validation(labels, DD.chem.data,
        5, cost=0.035);
Fs <- F.measure.single.over.classes(labels, out$predictions);
Fs$average[4];
labels[labels <= 0] <- 0;
auc <- AUC.single.over.classes(labels, out$scores);
auc$average
PXR <- precision.at.multiple.recall.level.over.classes(labels,
        out$scores, seq(from=0.1, to=1, by=0.1));
PXR$avgPXR
@
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\begin{thebibliography}{}
\bibitem[\protect\citeauthoryear{Bertoni et al.}{2011}]{Bertoni11}
Bertoni, A., Frasca, M., Valentini, G. (2011).
\newblock COSNet: A Cost Sensitive Neural Network for Semi-supervised Learning in Graphs.
{\it ECML/PKDD (1)} {\bf 6911}, 219-234.

\bibitem[\protect\citeauthoryear{Frasca {\em et~al.}}(2013)]{Frasca13}
Frasca, M., Bertoni, A., and Valentini, G. (2013).
\newblock A neural network algorithm for semi-supervised node label learning
  from unbalanced data.
{\it Neural Networks\/}, {\bf 43}(0), 84 -- 98.

\bibitem[\protect\citeauthoryear{von Mering et al.}{2002}]{vonMering02}
Von Mering, C., Krause, R., Snel, B., Cornell, M., Oliver, S., Fields, S., and Bork, P. (2002).
\newblock  Comparative assessment of large-scale data sets of protein-protein interactions.
{\it Nature} {\bf 417} 399-403.

\bibitem[\protect\citeauthoryear{Ashburner, M. et~al}{2000}]{GO00}
Ashburner, M. et al. (2000), 
\newblock Gene ontology: tool for the unification of biology. The
  Gene Ontology Consortium.
{\it Nature genetics\/} \textbf{25}~(1) 25--29.

\bibitem[\protect\citeauthoryear{Ling and Sheng}{2007}]{Ling07}
Ling, C. X. and Sheng, V. S. (2007).
\newblock {Cost-sensitive Learning and the Class Imbalanced Problem\/}.

\end{thebibliography}
\end{document}

\name{runSubnet}
\alias{runSubnet}

\title{
Realizing the network dynamics.
}
\description{
Function to simulate the dynamics of the network composed of unlabeled nodes.
}
\usage{
runSubnet(W, labeling, alpha_value, c_value, cost)
}

\arguments{
  \item{W}{
square symmetric named matrix, whose componemts are in the interval [0,1]. The i,j-th component is a similarity 
		index between node i and node j. The components of the diagonal of W are zero. Rows and colummns should be named identically.  
}
  
  \item{labeling}{
vector of node labels: 1 for positive examples, -1 for negative examples, 0 for unlabeled nodes
}
  \item{alpha_value}{
real value in [0, pi/2[, determining the neuron activation values: sin(alpha) and -cos(alpha).
}
  \item{c_value}{
real value  used as activation threshold for each neuron
}
 
  \item{cost}{
real value corresponding to beta parameter in the equation eta = beta*|tan((alpha - pi/4)*2)|, where eta is 
       the coefficient of the regularization term in the energy function (Frasca et al. 2013). If cost = 0 (default) 
       the unregularized version is executed. The higher the value of cost, the more the influence of the regularization term. 
       It is suggested using small values for this parameter (e.g. cost = 0.00001) 
}
}
\details{
Function to simulate the subnetwork composed of the unlabeled genes, in which each neuron has {sin(alpha_value), -cos(alpha_value)} as activation value, and 
	in which each neuron has a threshold "c_value" minus the contribution from the labeled neighbors.
}
\value{
list with three components:
	\item{ state }{Named vector of prediction (at equilibrium) for unlabeled nodes}
	\item{ scores}{Named vector of scores (at equilibrium)  for unlabeled nodes }
	\item{ iter }{Number of iterations of the network until convergence}
}

\references{
Frasca M., Bertoni A., Re M., Valentini G.: A neural network algorithm for semi-supervised node label learning from unbalanced data. Neural Networks, Volume 43, July, 2013 Pages 84-98.
}

\examples{
library(bionetdata);
data(Yeast.STRING.data);
data(Yeast.STRING.FunCat);
n<-nrow(Yeast.STRING.data);
## removing dummy node 00
Yeast.STRING.FunCat <- Yeast.STRING.FunCat[,
                        -which(colnames(Yeast.STRING.FunCat) == "00")];
class <- 1;
labels <- as.vector(Yeast.STRING.data[, class]);
names(labels) <- rownames(Yeast.STRING.FunCat);
labels <- as.vector(Yeast.STRING.FunCat[, class]);
names(labels) <- rownames(Yeast.STRING.FunCat);
folds <- find.division.strat(labels, 1:n, 3);
labels[labels <= 0] <- -1;
test.set <- folds[[1]];
training.set <- setdiff(1:n, test.set);
labels[test.set] <- 0;
res <- runSubnet(Yeast.STRING.data, labels, alpha=1, c=0, cost=0.0001);
str(res);
}

\name{find.division.strat}
\alias{find.division.strat}
\title{
Compute a stratified random partition of the input data
}
\description{
Function to determine a random partition of the labeled input vector into a fixed number of folds, such that each fold has around the same proportion of two-class labels.
}
\usage{
find.division.strat(labels, vett, n_fold)
}

\arguments{
  \item{labels}{
binary -1/1 label vector. labels[i] is the label for the element vett[i]. 
}
  \item{vett}{
vector to be partitioned
}
  \item{n_fold}{
number of folds in which the argument vett must be partitioned
}
}
\details{
The input vector "vett" is randomly partitioned into "n_fold" folds ensuring each fold contains roughly the same proportions of positives and negative labels, according to the labeling "labels"
}
\value{
List with n_fold elements, the i-th element is a vector corresponding to i-th fold.
}


\examples{
n <- 100;
vett <- runif(n, 0, 1)
labels <- c(rep(1, floor(n/3)), rep(-1, ceiling(2*n/3)));
n_fold <- 5;
fold_list <- find.division.strat(labels, vett, n_fold);
length(fold_list);
## number of positives in the first fold
sum(labels(fold_list[[1]]) > 0);
}

\seealso{
\code{\link{find.division.not.strat}}
}

\name{reg_data}
\alias{reg_data}
\title{
Function to compute the regularized version of COSNet (Frasca et al. 2013)
}
\description{
This function modifies the weights and the thresholds of the network to realized the COSNet regularization.
}
\usage{
reg_data(W, theta, eta, M, m, pos_num)
}
\arguments{
  \item{W}{
square symmetric named matrix of the network weights. The components of W are in the [0,1] interval. The i,j-th component is the weight between neuron i and neuron j. The components of the diagonal of W are 0
}
  \item{theta}{
vector of the neuron activation thresholds
}
  \item{eta}{
real value corresponding to the eta regularization coefficient in the energy function (Frasca et al. 2013). If eta = 0 no regularization is applied. The higher the value of eta, the more the influence of the regularization term  
}
  \item{M}{
positive neuron activation value
}
  \item{m}{
negative neuron activation value
}
  \item{pos_num}{
number of expected positive neurons in the equilibrium state of the network
}
}
\value{
list of two element: 
\item{W}{the regularized connection matrix}
\item{theta}{regularized threshold vector}
}

\examples{
library(bionetdata);
data(Yeast.STRING.data);
n <- nrow(Yeast.STRING.data);
dim(Yeast.STRING.data);
range(Yeast.STRING.data);
## setting values for parameter alpha, for the rate of positive examples,
## for neuron thresholds and for eta parameter
alpha <- 1;
pos.rate <- 0.01;
thresholds <- runif(n);
range(thresholds);
eta <- 0.001;
a <- reg_data(Yeast.STRING.data, thresholds, eta, sin(alpha),
    -cos(alpha), ceiling(pos.rate*n));
## new connection matrix
dim(a$W);
range(a$W);
## new thresholds
range(a$theta);
}

\references{
Frasca M., Bertoni A., Re M., Valentini G.: A neural network algorithm for semi-supervised node label learning from unbalanced data. Neural Networks, Volume 43, July, 2013 Pages 84-98.
}

\name{COSNet-package}
\alias{COSNet-package}
\docType{package}
\title{
R package for binary classification and node ranking on partially labeled graphs with unbalanced labels.
}
\description{
Algorithm based on cost-sensitive neural network for predicting 
node labels in a semi-supervised setting.  
}
\details{
\tabular{ll}{
Package: \tab COSNet\cr
Type: \tab Package\cr
Version: \tab 1.5.1\cr
Date: \tab 2015-11-06\cr
License: \tab GPL (>= 2) \cr
LazyLoad: \tab yes\cr
}
This package implements the COSNet algorithm (Frasca et al. 2013). COSNet is a semi-supervised cost-sensitive neural network for predicting 
node labels in partially labeled graphs. The algorithm is able in inferring a labeling for unlabeled nodes in the graph starting from the graph topology and the known labels.
}
\author{
\emph{Marco Frasca}, and \emph{Giorgio Valentini}

DI, Dipartimento di Informatica

Universita' degli Studi di Milano

\email{\{frasca,valentini\}@di.unimi.it}

Maintainer: 
\emph{Marco Frasca} 
}


\references{
Frasca M., Bertoni A., Re M., Valentini G.: A neural network algorithm for semi-supervised node label learning from unbalanced data. Neural Networks, Volume 43, July, 2013 Pages 84-98.

Bertoni A., Frasca M., Valentini G.: COSNet: a Cost Sensitive Neural Network for Semi-supervised Learning in Graphs. ECML PKDD'11 Proceedings of the 2011 European conference on Machine learning and knowledge discovery in databases - Volume Part I. Pages 219-234 
}

\keyword{ package }

\name{generate_labels}
\alias{generate_labels}

\title{
Generate random labels
}

\description{
Function to generate a vector of random labels
}

\usage{
generate_labels(n, pos_rate)
}

\arguments{
  \item{n}{
number of labels to be generated
}
  \item{pos_rate}{
rate of expected positive labels
}
}

\details{
This function generates "n" random labels in {-1, 1} drawn from the binomial distribution B(n, pos_rate)
}

\value{
-1/1 vector of length "n" containing the generated labels
}

\seealso{
\code{generate_points}
}
\examples{
pos_rate <- 0.3;					
n <- 100;
## generating n random labels with 0.3 expected rate of positive labels
random_labels <- generate_labels(n, pos_rate);
sum(random_labels > 0);
}

\name{optimizep}
\alias{optimizep}

\title{
Optimizing algorithm parameters
}
\description{
Function to learn the parameters "alpha", determining neurons activation values, and the neuron threshold "c".
}
\usage{
optimizep(pos_vect, neg_vect, training_labels)
}

\arguments{
  \item{pos_vect}{
vector of abscissae of the points to be separated
}
  \item{neg_vect}{
vector of ordinates of the points to be separated
}
  \item{training_labels}{
  1/-1 vector of point labels
}
}
\details{
This function computes the optimal angle "alpha" and the optimal threshold "c". For each labeled neuron k, a point (pos_vect[k], neg_vect[k]) is considered.
	 Points are labeled according to the labels contained in the vector "training_labels". Then the straight line, among those with positive slope, which separates these points by maximizing the F-score is learned. The line is represented by the angle alpha formed with the "x" axis, and its intercept "q" with "y" axis.
   When separating points by a straight line, there are two possibility: 1) Considering as positive the half-plane above the line; 2) Considering as positive
	 the half-plane below the line. The procedure investigates both these possibilities, and also returns which choice between 1) and 2) corresponds to the best F-score.
}
\value{
list "res" with 4 components:

  \item{res$alpha}{value of the optimum angle alpha}
  \item{res$c}{value of the optimum threshold c}
  \item{res$Fscore}{ value of the optimum F-score}
  \item{res$pos_half}{ the position of the positive half-plane : > 0  in case 1),  < 0 in case 2)  }
}

\examples{
library(bionetdata);
data(Yeast.STRING.data);
data(Yeast.STRING.FunCat);
n <- nrow(Yeast.STRING.data);
## removing dummy node 00
Yeast.STRING.FunCat <- Yeast.STRING.FunCat[, 
                        -which(colnames(Yeast.STRING.FunCat)=="00")];
## selecting the class with index 1
class <- 1;
labels <- as.vector(Yeast.STRING.data[, class]);
names(labels) <- rownames(Yeast.STRING.FunCat);
labels <- as.vector(Yeast.STRING.FunCat[, class]);
names(labels) <- rownames(Yeast.STRING.FunCat);
## partitioning the data
folds <- find.division.strat(labels, 1:n, 3);
labels[labels <= 0] <- -1;
test.set <- folds[[1]];
training.set <- setdiff(1:n, test.set);
labels[test.set] <- 0;
## generating the points to be separated
points <- generate_points(Yeast.STRING.data, test.set, labels);
opt_parameters <- optimizep(points$pos_vect[training.set],
                    points$neg_vect[training.set], labels[training.set]);
str(opt_parameters);
}

\seealso{
\code{\link{optimize_pos_above}}
}

\name{generate_points}
\alias{generate_points}

\title{
Compute the points to be separated in Step 2 of COSNet algorithm (Frasca et al. 2013)
}
\description{
This function associates each labeled node with a point in the plane, whose 
coordinates are respectively the weighted sum of its positive and negative neighborhoods
}

\usage{
generate_points(W, unlabeled, labeling)
}

\arguments{
  \item{W}{
square symmetric named matrix, whose components are in the [0,1] interval. The i,j-th component is the weight between node i and node j. The components of the diagonal of W are zero.
}
  \item{unlabeled}{
vector of the indices of the unlabeled nodes
}
  \item{labeling}{
vector of node labels : 1 for positive nodes, -1 for negative nodes, 0 for unlabeled nodes
}
}

\details{
For each labeld node k,  a point (pos_vect[k], neg_vect[k]) is computed, where pos_vect[k] is the whighted sum of the positive neighbors of node k and neg_vect[k] is the weighted sum  of negative neighbors of node k. 
}

\value{
List of two element: 
\item{pos_vect}{ is the vector of the abscissae; pos_vect[k] contains the whighted sum of the positive neighbors of node k}
\item{neg_vect}{ is the vector of the ordinates; neg_vect[k] contains the whighted sum of the negative neighbors of node k}
}

\references{

Frasca M., Bertoni A., Re M., Valentini G.: A neural network algorithm for semi-supervised node label learning from unbalanced data. Neural Networks, Volume 43, July, 2013 Pages 84-98.
}

\examples{
## randomly generating labels
labels <- generate_labels(100, 0.3);
unlabeled <- sample(1:100, 10);
labels[unlabeled] <- 0;
## randomly generating connection matrix
W <- matrix(sample(1:10000, 100*100)/1000, nrow = 100);
diag(W) <- 0;
points <- generate_points(W, unlabeled, labels);
points$pos_vect[1:5];
points$neg_vect[1:5];
}

\name{optimize_pos_above}
\alias{optimize_pos_above}
\title{
Alternative algortihm for optimizing parameters
}
\description{
Alternative algorithm to compute the two parameters: 'alpha', determining neurons activation values, and the neuron thresholds 'c'.
}
\usage{
optimize_pos_above(pos_vect, neg_vect, training_labels, res)
}
\arguments{
  \item{pos_vect}{
vector of abscissae of the points to be separated
}
  \item{neg_vect}{
vector of ordinates of the points to be separated
}
  \item{training_labels}{
1/-1 vector of the point labels
}
  \item{res}{
list containing the optimum angle (field alpha), neuron threshold (field c), maximum F-score (field Fscore) and positive halfplane (field pos_half) computed by the procedure corresponding to the choice 1) of function \code{optimizep}.
}
}
\details{
Function to optimize the the parameters 'alpha' and 'c' when the function \code{optimizep} determines that the maximum F-score corresponds to the half-plane above the separation line. The algorithm works in three steps:
1) Selecting all the points which lie on the Y-axis. The aim is to choose a positive point which will be the center of the line bundle we
consider in the next step. We sort the selected points by ordinate and for each positive point we compute the F-score of the almost
vertical line (but with negative slope) crossing this point considering solely the selected points. Then we choose the
point k which corresponds to the highest F-score.
2) The algorithm computes the slopes of the lines crossing the point k and each point not lying on the Y-axis. Then it searches
the line, among those with negative slope, which maximizes the F-score criterion by sorting the computed lines according to their 
slopes in an increasing order. Consequently, the angle alpha relative to the optimum line is in the interval ]pi/2,  pi[.
3) Compute the intercepts of the straight lines whose slope is tan(alpha) and crossing each available point. The optimum line is identified
by scanning the computed lines according to their intercept in an increasing order. Let q be the intercept of the optimum line
y = tan(alpha)z + q, then we set c = -cos(alpha)q.
If there are no positive point with abscissa 0, the function returns the optimal parameters contained in input argument 'res' computed by the procedure corresponding to the choice 1) of function \code{optimizep}.
}
\value{
list res with 3 components
  \item{res$alpha}{ value of the optimum angle alpha}
  \item{res$c}{ value of the optimum threshold c}
  \item{res$Fscore}{ value of the optimum F-score}
  \item{res$pos_half}{position of the positive half-plane (-1 below, 1 above the optimum straith line)}  
}

\examples{
library(bionetdata);
data(Yeast.STRING.data);
data(Yeast.STRING.FunCat);
n <- nrow(Yeast.STRING.data);
## removing dummy node 00
Yeast.STRING.FunCat <- Yeast.STRING.FunCat[,
                        -which(colnames(Yeast.STRING.FunCat) == "00")];
## selecting the class with index 1
class <- 1;
labels <- as.vector(Yeast.STRING.data[, class]);
names(labels) <- rownames(Yeast.STRING.FunCat);
labels <- as.vector(Yeast.STRING.FunCat[, class]);
names(labels) <- rownames(Yeast.STRING.FunCat);
## partitioning the data
folds <- find.division.strat(labels, 1:n, 3);
labels[labels <= 0] <- -1;
test.set <- folds[[1]];
training.set <- setdiff(1:n, test.set);
labels[test.set] <- 0;
points <- generate_points(Yeast.STRING.data, test.set, labels);
## setting values for the parameter
res <- list(alpha=pi/2, c=0, Fscore=0, pos_half=-1);
opt_parameters <- optimize_pos_above(points$pos_vect[training.set],
                    points$neg_vect[training.set], labels[training.set], res);
str(opt_parameters);
}

\seealso{
\code{\link{optimizep}}
}

\name{find.division.not.strat}
\alias{find.division.not.strat}

\title{
Random partitioning of input data
}
\description{
Function to determine a random partition of the input vector into a specifiend number of folds.
}
\usage{
find.division.not.strat(vett, n_fold)
}

\arguments{
  \item{vett}{
vector to be partitioned
}
  \item{n_fold}{
number of folds in which the argument vett must be partitioned
}
}

\value{
List with n_fold elements, the i-th element is a vector corresponding to i-th fold.
}


\seealso{
\code{\link{find.division.strat}}
}
\examples{
n <- 100;
vett <- runif(n, 0, 1);
n_fold <- 5;
fold_list <- find.division.not.strat(vett, n_fold);
length(fold_list);
## indices of the first fold 
fold_list[[1]];
}

\name{COSNet}
\alias{COSNet}
\title{
Cost Sensitive Network for node label prediction on graphs with highly unbalanced labelings
}
\description{
This function realizes the COSNet algorithm (Frasca et al. 2013). COSNet is a semi-supervised algorithm based on parametric Hopfield networks for predicting labels for unlabeled nodes in graphs which are only partially labeled.  
}
\usage{
COSNet(W, labeling, cost = 0)
}
\arguments{
  \item{W}{
 	square symmetric named matrix, whose components are in the interval [0,1]. The i,j-th component is a similarity 
		index between node i and node j. The components of the diagonal of W are zero. Rows and columns should be named identically.  
}
  \item{labeling}{
vector of node labels: 1 for positive examples, -1 for negative examples, 0 for unlabeled nodes.
}
  \item{cost}{
real value corresponding to beta parameter in the equation eta = beta*|tan((alpha - pi/4)*2)|, where eta is 
       the coefficient of the regularization term in the energy function (Frasca et al. 2013). If cost = 0 (default) 
       the unregularized version is executed. "cost" is a real value that reduces or increases the influence of regularization 
       on the network dynamics. The higher the value of cost, the more the influence of the regularization term. 
       It is suggested using small values for this parameter (e.g. cost = 0.0001) 
}
}
\details{
\code{COSNet} contructs a Hopfield network whose connection 
   matrix is W, and it applies a cost-sensitive strategy to determine the network parameters starting from W and labels "labeling". 
   COSNet distinguishes between labeled (1, -1  components in "labeling") and unlabeled (zero components in "labeling") nodes, and it is made up by three steps:
		{1) Generating a random labeling (1, -1) for unlabeled nodes. }
		{2) Learning the parameters "alpha and "c" such that the line "cos(alpha)*y - sin(alpha)*x - q*cos(alpha) = 0 " linearly separates a suitable set of labeled points (in which each point corresponds to a labeled node) and optimizes (in terms of alpha and q) the F-score criterion. The output of this phase is the intercept "q" of the optimum line and the corresponding angle "alpha". Then each neuron has threshold c = - q*cos(alpha).}
		{3) Extending "c" and "alpha" to the subnetwork composed of only unlabeled nodes, and simulating it until an equilibrium state is reached. The dynamics of this network is regularized by adding a term to the energy function that is minimized when the proportion of positive in the network state is roughly the proportion of positives in the labeled part of the network. The parameter "cost" corresponds to the parameter beta  in the equation eta = beta*|tan((alpha - pi/4)*2)| (see Frasca et al. 2013). When the equilibrium state is reached, positive nodes will be predicted as positive for the current task.}
}
\value{
\code{COSNet} returns  a list with six elements:
	\item{ alpha }{the optimum angle }
	\item{ c}{the optimum threshold}
	\item{ Fscore }{the optimum F-score computed in Step 2}
	\item{ pred }{the vector of predictions for unlabeled nodes}
	\item{ scores}{the vector of scores for unlabeled nodes}
	\item{ iter }{number of iterations until convergence in Step 3}
}
\references{
Frasca M., Bertoni A., Re M., Valentini G.: A neural network algorithm for semi-supervised node label learning from unbalanced data. Neural Networks, Volume 43, July, 2013 Pages 84-98.
}

\examples{
library(bionetdata);
## loading Binary protein-protein interactions from the STRING 
## data base (von Mering et al. 2002)
data(Yeast.STRING.data)# "Yeast.STRING.data"
## FunCat classes annotations (0/1) for the genes included
## in Yeast.STRING.data. Annotations refer the funcat-2.1
## scheme, and funcat-2.1 data 20070316 data, available from the MIPS web site.
data(Yeast.STRING.FunCat) # "Yeast.STRING.FunCat"
labels <- Yeast.STRING.FunCat;
labels[labels == 0] <- -1;		
## excluding the dummy "00" root
labels <- labels[, -which(colnames(labels) == "00")];	
n <- nrow(labels);
k <- floor(n/10);
cat("k = ", k, "\n");
## choosing the first class
labeling <- labels[, 1];
## randomly choosing a subset of genes whose labels are hidden
hidden <- sort(sample(1:n, k));
hidden.labels <- labeling[hidden];
labeling[hidden] <- 0;
out <- COSNet(Yeast.STRING.data, labeling, 0);
prediction <- out$pred;
TP <- sum(hidden.labels == 1 & prediction == 1);
FN <- sum(hidden.labels == 1 & prediction == -1);
FP <- sum(hidden.labels == -1 & prediction == 1);
out2 <- COSNet(Yeast.STRING.data, labeling, 0.0001);
prediction <- out2$pred;
TP2 <- sum(hidden.labels == 1 & prediction == 1);
FN2 <- sum(hidden.labels == 1 & prediction == -1);
FP2 <- sum(hidden.labels == -1 & prediction == 1);
}

\name{cosnet.cross.validation}
\alias{cosnet.cross.validation}

\title{
Cross validation procedure for the COSNet algorithm
}
\description{
This function applies the function \code{COSNet} to the input data with a cross validation procedure.
}
\usage{
cosnet.cross.validation(labels, W, nfolds, cost)
}

\arguments{
  \item{labels}{
named matrix of node labels. The (i-j)-th component contains the label (1 for positive examples, -1 for negative examples) of node i for j-th  functional class to be predicted
}
  \item{W}{
square symmetric named matrix. The (i,j)-th component is a similarity index between node i and node j. The components of the diagonal of W are zero.
}
  \item{nfolds}{
integer corresponding to the number of desired folds
}
  \item{cost}{
real value that corresponds to the cost parameter of \code{COSNet}
}
}
\details{
\code{cosnet.cross.validation} runs the function \code{COSNet} on the input data through a cross validation procedure. For each class to be predicted (column of "labels"), both "W" and "labels" are partitioned into "nfolds" subsets and at each iteration the labels of a fold are hidden and predicted with function \code{COSNet}. When possible, input data are partitioned by ensuring the same proportion of positive and negative instances in each fold. 
}
\value{
List  with three elements:
	\item{labels}{1/-1 named input label matrix, in which rows correspond to nodes and columns to classes}
	 \item{predictions}{named 1/-1 prediction matrix,	in which rows correspond to nodes and columns to classes. The position i-j-th is 1 if the node i has been predicted as positive for the class j, -1 otherwise}
	 \item{scores}{named real score matrix, in which rows correspond to nodes and columns to classes. The position i-j-th is a real number corresponding to the internal energy at equlibrium for node i when predicting class j. This score is a "degree" of membership of  node i to the class j}
}

\seealso{
\code{\link{COSNet}}
}
\examples{
library(bionetdata);
data(Yeast.STRING.data)
data(Yeast.STRING.FunCat) # "Yeast.STRING.FunCat"
## excluding the dummy "00" root
Yeast.STRING.FunCat <- 
        Yeast.STRING.FunCat[, -which(colnames(Yeast.STRING.FunCat) == "00")];
nfolds <- 5;
res <- cosnet.cross.validation(Yeast.STRING.FunCat[, 1:50], Yeast.STRING.data,
        nfolds, 0.0001);
## computing performances
library(PerfMeas);
perf <- F.measure.single.over.classes(res$labels, res$predictions);
cat(perf$average);
}
